using System;
using System.Collections;
using System.Collections.Generic;
using Sage.SalesLogix.NetExtensions.SalesLogix;
using ICollection=Sage.SalesLogix.NetExtensions.SalesLogix.ICollection;

namespace Eventix.Schedules.ScheduleResource.SalesLogix
{
    public class MockPickList : IPickList
    {
        private List<IPickListItem> _items;

        public MockPickList(params string[] items)
        {
            _items = new List<IPickListItem>(items.Length);

            foreach (string item in items)
            {
                _items.Add(new MockPickListItem(item));
            }
        }

        #region IPickList Members

        public IPickListItem Add(string Text, string ShortText)
        {
            throw new Exception("The method or operation is not implemented.");
        }

        public bool AllowEdit
        {
            get { throw new Exception("The method or operation is not implemented."); }
        }

        public int DefaultItem
        {
            get { throw new Exception("The method or operation is not implemented."); }
        }

        public bool Fixed
        {
            get { throw new Exception("The method or operation is not implemented."); }
        }

        public string ID
        {
            get { throw new Exception("The method or operation is not implemented."); }
        }

        public IPickListItem ItemBySequence(int Sequence)
        {
            throw new Exception("The method or operation is not implemented.");
        }

        public IPickListItem ItemByShortText(string Value)
        {
            throw new Exception("The method or operation is not implemented.");
        }

        public IPickListItem ItemByText(string Value)
        {
            throw new Exception("The method or operation is not implemented.");
        }

        public bool MultiSelect
        {
            get { throw new Exception("The method or operation is not implemented."); }
        }

        public string Name
        {
            get { throw new Exception("The method or operation is not implemented."); }
        }

        public bool RequiredEntry
        {
            get { throw new Exception("The method or operation is not implemented."); }
        }

        public void Save()
        {
            throw new Exception("The method or operation is not implemented.");
        }

        public ICollection Select(PickListColumns Columns, string[] OldItemIDs, int Left, int Top, int Width, int Height)
        {
            throw new Exception("The method or operation is not implemented.");
        }

        public bool Sorted
        {
            get { throw new Exception("The method or operation is not implemented."); }
        }

        public IPickListItem this[string ItemID]
        {
            get { throw new Exception("The method or operation is not implemented."); }
        }

        public IPickListItem this[int index]
        {
            get { return _items[index]; }
        }

        #endregion

        #region ICollection Members

        public int Count
        {
            get { return _items.Count; }
        }

        object ICollection.this[int Index]
        {
            get { throw new Exception("The method or operation is not implemented."); }
        }

        #endregion

        #region IEnumerable Members

        public IEnumerator GetEnumerator()
        {
            return _items.GetEnumerator();
        }

        #endregion
    }
}